SystemOrganization addCategory: #ConfigurationOfGraphET!

Object subclass: #ConfigurationOfGraphET
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfGraphET'!

!ConfigurationOfGraphET class methodsFor: 'development support' stamp: 'AlexandreBergel 9/4/2013 15:50'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfGraphET class methodsFor: 'private' stamp: 'AlexandreBergel 9/4/2013 15:50'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfGraphET class methodsFor: 'private' stamp: 'AlexandreBergel 9/4/2013 15:50'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfGraphET class methodsFor: 'private' stamp: 'AlexandreBergel 9/4/2013 15:50'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfGraphET class methodsFor: 'metacello tool support' stamp: 'AlexandreBergel 9/4/2013 15:50'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfGraphET class methodsFor: 'loading' stamp: 'AlexandreBergel 9/4/2013 15:50'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfGraphET class methodsFor: 'loading' stamp: 'AlexandreBergel 9/4/2013 15:50'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfGraphET class methodsFor: 'loading' stamp: 'AlexandreBergel 9/4/2013 15:50'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfGraphET class methodsFor: 'accessing' stamp: 'AlexandreBergel 9/4/2013 15:50'!
project

	^self new project! !

!ConfigurationOfGraphET class methodsFor: 'development support' stamp: 'AlexandreBergel 9/4/2013 15:50'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfGraphET methodsFor: 'baselines' stamp: 'AlexandreBergel 9/4/2013 16:57'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/ObjectProfile/GraphET/main'.
		spec 
			package: 'Graph-ET'.

		spec project: 'Roassal' with: [
				spec
					className: 'ConfigurationOfRoassal';
					file: 'ConfigurationOfRoassal';
					version: #'development';
					repository: 'http://smalltalkhub.com/mc/ObjectProfile/Roassal/main' ].

		spec group: 'default' with: #( 'Roassal' 'Graph-ET' ). ].
! !

!ConfigurationOfGraphET methodsFor: 'accessing' stamp: 'AlexandreBergel 9/4/2013 15:50'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfGraphET methodsFor: 'symbolic versions' stamp: 'AlexandreBergel 9/4/2013 15:52'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1-baseline'.
! !

!ConfigurationOfGraphET methodsFor: 'snapshots' stamp: 'TudorGirba 9/10/2013 08:46'!
populateSpec: aSpec with: list
	"generated by Snapshotcello
	
	creates a spec object for the package and the version stored in the list"
	
	list do: [:each |
		aSpec package: each third with: [
			aSpec file: (each first  copyUpToLast: $. ).
			aSpec repository: each second ] ]! !

!ConfigurationOfGraphET methodsFor: 'accessing' stamp: 'AlexandreBergel 9/4/2013 15:50'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfGraphET methodsFor: 'snapshots' stamp: 'TudorGirba 9/10/2013 08:46'!
snapshot1
	"generated by Snapshotcello"

	^ #( 
		#('ConfigurationOfRoassal-TudorGirba.1186.mcz'  'http://www.smalltalkhub.com/mc/ObjectProfile/Roassal/main/'  'ConfigurationOfRoassal' ) 
		#('Graph-ET-TudorGirba.76.mcz'  'http://smalltalkhub.com/mc/ObjectProfile/GraphET/main/'  'Graph-ET' ) 
		#('Roassal-AlexandreBergel.668.mcz'  'http://www.smalltalkhub.com/mc/ObjectProfile/Roassal/main/'  'Roassal' ) 
		#('RoassalMorphic-AlexandreBergel.146.mcz'  'http://www.smalltalkhub.com/mc/ObjectProfile/Roassal/main/'  'RoassalMorphic' ) 
	)! !

!ConfigurationOfGraphET methodsFor: 'symbolic versions' stamp: 'TudorGirba 9/10/2013 08:46'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '0.1-baseline'.

	spec for: #'pharo2.x' version: '0.2-snapshot'.
! !

!ConfigurationOfGraphET methodsFor: 'versions' stamp: 'AlexandreBergel 9/4/2013 15:50'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: ''.
		spec author: 'AlexandreBergel'.
		spec timestamp: '9/4/2013 15:50'. ].
! !

!ConfigurationOfGraphET methodsFor: 'snapshot versions' stamp: 'TudorGirba 9/10/2013 08:46'!
version02snapshot: spec
	"generated by Snapshotcello"
	<version: '0.2-snapshot'>

	spec for: #common do: [
		self populateSpec: spec with: self snapshot1 ]! !
